summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--NEWS3
-rw-r--r--src/seq.c24
-rw-r--r--tests/local.mk2
-rwxr-xr-xtests/misc/seq-epipe.sh46
-rwxr-xr-xtests/misc/seq-io-errors.sh46
5 files changed, 116 insertions, 5 deletions
diff --git a/NEWS b/NEWS
index 189a03abc..6018aa91b 100644
--- a/NEWS
+++ b/NEWS
@@ -15,6 +15,9 @@ GNU coreutils NEWS -*- outline -*-
stty --help no longer outputs extraneous gettext header lines
for translated languages. [bug introduced in coreutils-8.24]
+ seq now immediately exits upon write errors.
+ [This bug was present in "the beginning".]
+
** Changes in behavior
seq no longer accepts 0 value as increment, and now also rejects NaN
diff --git a/src/seq.c b/src/seq.c
index de92bc278..1b9da40fb 100644
--- a/src/seq.c
+++ b/src/seq.c
@@ -278,6 +278,15 @@ long_double_format (char const *fmt, struct layout *layout)
}
}
+static void ATTRIBUTE_NORETURN
+io_error (void)
+{
+ /* FIXME: consider option to silently ignore errno=EPIPE */
+ error (0, errno, _("standard output"));
+ clearerr (stdout);
+ exit (EXIT_FAILURE);
+}
+
/* Actually print the sequence of numbers in the specified range, with the
given or default stepping and format. */
@@ -295,7 +304,8 @@ print_numbers (char const *fmt, struct layout layout,
for (i = 1; ; i++)
{
long double x0 = x;
- printf (fmt, x);
+ if (printf (fmt, x) < 0)
+ io_error ();
if (out_of_range)
break;
x = first + i * step;
@@ -336,10 +346,12 @@ print_numbers (char const *fmt, struct layout layout,
break;
}
- fputs (separator, stdout);
+ if (fputs (separator, stdout) == EOF)
+ io_error ();
}
- fputs (terminator, stdout);
+ if (fputs (terminator, stdout) == EOF)
+ io_error ();
}
}
@@ -506,14 +518,16 @@ seq_fast (char const *a, char const *b)
output buffer so far, and reset to start of buffer. */
if (buf_end - (p_len + 1) < bufp)
{
- fwrite (buf, bufp - buf, 1, stdout);
+ if (fwrite (buf, bufp - buf, 1, stdout) != 1)
+ io_error ();
bufp = buf;
}
}
/* Write any remaining buffered output, and the terminator. */
*bufp++ = *terminator;
- fwrite (buf, bufp - buf, 1, stdout);
+ if (fwrite (buf, bufp - buf, 1, stdout) != 1)
+ io_error ();
IF_LINT (free (buf));
}
diff --git a/tests/local.mk b/tests/local.mk
index 424f4609c..d3afb6e5c 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -235,6 +235,8 @@ all_tests = \
tests/misc/ptx.pl \
tests/misc/test.pl \
tests/misc/seq.pl \
+ tests/misc/seq-epipe.sh \
+ tests/misc/seq-io-errors.sh \
tests/misc/seq-long-double.sh \
tests/misc/seq-precision.sh \
tests/misc/head.pl \
diff --git a/tests/misc/seq-epipe.sh b/tests/misc/seq-epipe.sh
new file mode 100755
index 000000000..21e932293
--- /dev/null
+++ b/tests/misc/seq-epipe.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+# Test for proper detection of EPIPE with ignored SIGPIPE
+
+# Copyright (C) 2016 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ seq
+
+# upon EPIPE with signals ignored, 'seq' should exit with an error.
+(trap '' PIPE;
+ timeout 10 sh -c '( (seq inf 2>err ; echo $?>code) | head -n1)'>/dev/null)
+
+# Exit-code must be 1, indicating 'write error'
+cat << \EOF > exp || framework_failure_
+1
+EOF
+if test -e code ; then
+ compare exp code || fail=1
+else
+ # 'exitcode' file was not created
+ warn_ "missing exit code file (seq failed to detect EPIPE?)"
+ fail=1
+fi
+
+# The error message must begin with "standard output:"
+# (but don't hard-code the strerror text)
+compare_dev_null_ /dev/null err
+if ! grep -qE '^seq: standard output: .+$' err ; then
+ warn_ "seq emitted incorrect error on EPIPE"
+ fail=1
+fi
+
+Exit $fail
diff --git a/tests/misc/seq-io-errors.sh b/tests/misc/seq-io-errors.sh
new file mode 100755
index 000000000..800718793
--- /dev/null
+++ b/tests/misc/seq-io-errors.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+# Test for proper detection of I/O errors in seq
+
+# Copyright (C) 2016 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ seq
+
+if ! test -w /dev/full || ! test -c /dev/full; then
+ skip_ '/dev/full is required'
+fi
+
+# Run 'seq' with a timeout, preventing infinite-loop run.
+# expected returned codes:
+# 1 - seq detected an I/O error and exited with an error.
+# 124 - timed-out (seq likely infloop)
+# other - unexpected error
+timed_seq_fail() { timeout 10 seq "$@" >/dev/full 2>/dev/null; }
+
+
+# Test infinite sequence, using fast-path method (seq_fast).
+returns_ 1 timed_seq_fail 1 inf || fail=1
+
+# Test infinite sequence, using slow-path method (print_numbers).
+returns_ 1 timed_seq_fail 1.1 .1 inf || fail=1
+
+# Test non-infinite sequence, using slow-path method (print_numbers).
+# (despite being non-infinite, the entire sequence should take long time to
+# print. Thus, either an I/O error is detected immediately, or seq will
+# timeout).
+returns_ 1 timed_seq_fail 1 0.0001 99999999 || fail=1
+
+Exit $fail